Imports System.DirectoryServices
Imports System.Configuration

Public Class Config
  Private Shared ms_entry As DirectoryEntry
  Private Sub New()

  End Sub
  Shared Sub New()
    'login to ADAM using the process identity (if not impersonating)
    'grant read permissin to the application pool process identity
    'this application runs under (NETWORK_SERVICE by default)
    Dim ADAMPath As Object = ConfigurationSettings.AppSettings("ADAMPath")
    If ADAMPath Is Nothing Then Throw New Exception("Can't find ADAMPath in the config file")
    ms_entry = New DirectoryEntry(ADAMPath.ToString)
  End Sub

  Public Shared Function GetConfigItemString(ByVal p_key As String) As String
    Return GetConfigItem(p_key).Properties("SS-appsettingsattr").Item(0).ToString
  End Function

  Public Shared Function GetConfigItem(ByVal p_key As String) As Object
    Dim mySearcher As New DirectorySearcher(ms_entry, "(CN=" + p_key + ")")
    Dim l_s As SearchResult = mySearcher.FindOne
    If l_s Is Nothing Then Throw New Exception("nothing found for query " + p_key)
    Return l_s.GetDirectoryEntry
  End Function

End Class
